package jeu.echec.pieces;
/**
 * Classe Fou, représente les pièces des Fou
 * @author mouss
 *
 */
public class Fou extends Piece {
	 
    public Fou(boolean estBlanc) {
        super(estBlanc);
    }
 
 
    public void dessiner() {
        if (estBlanc) {
            System.out.print("FB");
        } else {
            System.out.print("FN");
        }
    }
    
	private int x;
    private int y;
	
    /**
     * Récupère la position en X
     * @return
     */
    public int getX() {
        return x;
    }

    /**
     * Récupère la position en Y
     * @return
     */
    public int getY() {
        return y;
    }
    
    /**
     * Défini la position en X
     * @param x
     */
    public void setX(int x) {
        this.x = x;
    }

    /**
     * Défini la position en Y
     * @param y
     */
    public void setY(int y) {
        this.y = y;
    }
    
    /**
     * Affichage d'une coordonnée
     * @return
     */
    public String toString(){
    	
    	String pos="", alphabet = "";
		if(this.getX() == 0) {
			alphabet = "a";
		}
		if(this.getX() == 1) {
			alphabet = "b";			
		}
		if(this.getX() == 2) {
			alphabet = "c";
		}
		if(this.getX() == 3) {
			alphabet = "d";
		}
		if(this.getX() == 4) {
			alphabet = "e";
		}
		if(this.getX() == 5) {
			alphabet = "f";
		}
		if(this.getX() == 6) {
			alphabet = "g";
		}
		if(this.getX() == 7) {
			alphabet = "h";
		}

        pos += alphabet+this.getY();

        return pos;
    }
    
    public void setPosition(int colonne, int ligne) {
    	setX(ligne);
    	setY(colonne);
    }
 
    private static Boolean chemin(int departLigne, int departColonne, int arriveeligne,int arriveColonne) {
        return ((Math.abs(departLigne - arriveeligne) == Math.abs(departColonne
                -  arriveColonne)));
    }
 
    /**
     * Les déplacements du fou
     */
    public boolean deplacementValide(int departLigne, int departColonne, int arriveeligne,int arriveColonne) {
        return chemin(departLigne, departColonne, arriveeligne, arriveColonne);
    }
 
 
}