package jeu.echec.pieces;

/**
 * La classe Pièce, classe mère de toutes les pièces (Pion, Roi, Fou, Reine, etc..) 
 * @author mouss
 *
 */
public abstract class Piece {
	private int x;
    private int y;
	
    /**
     * Récupère la position en X
     * @return
     */
    public int getX() {
        return x;
    }

    /**
     * Récupère la position en Y
     * @return
     */
    public int getY() {
        return y;
    }
    
    /**
     * Défini la position en X
     * @param x
     */
    public void setX(int x) {
        this.x = x;
    }

    /**
     * Défini la position en Y
     * @param y
     */
    public void setY(int y) {
        this.y = y;
    }

    /**
     * Affichage d'une coordonnée
     * @return
     */
    public String toString(){
    	
    	String pos="", alphabet = "";
		if(this.getX() == 0) {
			alphabet = "a";
		}
		if(this.getX() == 1) {
			alphabet = "b";			
		}
		if(this.getX() == 2) {
			alphabet = "c";
		}
		if(this.getX() == 3) {
			alphabet = "d";
		}
		if(this.getX() == 4) {
			alphabet = "e";
		}
		if(this.getX() == 5) {
			alphabet = "f";
		}
		if(this.getX() == 6) {
			alphabet = "g";
		}
		if(this.getX() == 7) {
			alphabet = "h";
		}

        pos += alphabet+this.getY();

        return pos;
    }
    
    
    /**
     * Récupère la position d'une pièce
     * @param colonne
     * @param ligne
     */
    public void setPosition(int colonne, int ligne) {
    	setX(ligne);
    	setY(colonne);
    }
    
   
    
    
    
    boolean estBlanc;
    /**
	* Construit une pièce d’une couleur.
	* @param couleur Couleur de la pièce: Piece.BLANC ou Piece.NOIR.
	* @param type La valeur du type doit ^etre l’une des constantes entières
	* de cette classe.
	*/
    public Piece(boolean estBlanc) {
        this.estBlanc = estBlanc;
    }
    public boolean estBlanc() {
        return estBlanc; 
    }
    public abstract void dessiner();
    
    //public abstract void pieceJouable();
    public abstract boolean deplacementValide(int departLigne, int departColonne, int arriveeligne, int arriveColonne);

 
    

}
  
