package jeu.echec.pieces;

/**
 * Classe Pion, représente les pièces des Pion
 * @author mouss
 *
 */
public class Pion extends Piece {
	 

    public Pion(boolean estBlanc) {
        super(estBlanc);
    }
 
    public void dessiner() {
        if (this.estBlanc) {
            System.out.print("PB");
        } 
        if (!(this.estBlanc)) {
            System.out.print("PN");
 
        }
    }
    
	private int x;
    private int y;
	
    /**
     * Récupère la position en X
     * @return
     */
    public int getX() {
        return x;
    }

    /**
     * Récupère la position en Y
     * @return
     */
    public int getY() {
        return y;
    }
    
    /**
     * Défini la position en X
     * @param x
     */
    public void setX(int x) {
        this.x = x;
    }
    

    /**
     * Défini la position en Y
     * @param y
     */
    public void setY(int y) {
        this.y = y;
    }
    
    /**
     * Affichage d'une coordonnée
     * @return
     */
    public String toString(){
    	
    	String pos="", alphabet = "";
		if(this.getX() == 0) {
			alphabet = "a";
		}
		if(this.getX() == 1) {
			alphabet = "b";			
		}
		if(this.getX() == 2) {
			alphabet = "c";
		}
		if(this.getX() == 3) {
			alphabet = "d";
		}
		if(this.getX() == 4) {
			alphabet = "e";
		}
		if(this.getX() == 5) {
			alphabet = "f";
		}
		if(this.getX() == 6) {
			alphabet = "g";
		}
		if(this.getX() == 7) {
			alphabet = "h";
		}

        pos += alphabet+this.getY();

        return pos;
    }
    
    /**
     * Récupère la position d'une pièce
     * @param colonne
     * @param ligne
     */
    public void setPosition(int colonne, int ligne) {
    	setX(ligne);
    	setY(colonne);
    }
 
    /**
     * Les déplacements du pion
     */
    public boolean deplacementValide(int departLigne, int departColonne, int arriveeligne,int arriveColonne) {
             
            if (this.estBlanc) {
                return (((departColonne == arriveColonne) && departLigne == (arriveeligne + 1))
                        || ((departLigne == 6) && (departColonne == arriveColonne) && (departLigne == (arriveeligne + 2)))
                        || ((departLigne == (arriveeligne + 1))
                                && (Math.abs(departColonne - arriveColonne) == 1)));
                 
            }
            else {
                return (((departColonne == arriveColonne) && departLigne == (arriveeligne - 1))
                        || ((departLigne == 1) && (departColonne == arriveColonne) && (departLigne == (arriveeligne - 2)))
                        || ((departLigne == (arriveeligne - 1))
                                && (Math.abs(departColonne - arriveColonne) == 1)));
            }
             
 
 
    }
}
